package org.firstinspires.ftc.teamcode.cometbots.paths;

import static com.qualcomm.hardware.lynx.commands.core.LynxSetMotorPIDFControlLoopCoefficientsCommand.InternalMotorControlAlgorithm.Max;

import androidx.annotation.NonNull;

import com.acmerobotics.dashboard.telemetry.TelemetryPacket;
import com.acmerobotics.roadrunner.Action;
import com.acmerobotics.roadrunner.SequentialAction;
import com.acmerobotics.roadrunner.SleepAction;
import com.acmerobotics.roadrunner.ftc.Actions;
import com.qualcomm.robotcore.eventloop.opmode.Autonomous;
import com.qualcomm.robotcore.eventloop.opmode.OpMode;
import com.qualcomm.robotcore.util.ElapsedTime;

//import org.firstinspires.ftc.teamcode.cometbots.CometBotTeleopCompetition;
//import org.firstinspires.ftc.teamcode.cometbots.paths.HighBasketPath1;
import org.firstinspires.ftc.teamcode.pedroPathing.follower.Follower;
//import org.firstinspires.ftc.teamcode.subsystem.AutoPark;
import org.firstinspires.ftc.teamcode.cometbots.paths.HighBasketPath1;
import org.firstinspires.ftc.teamcode.subsystem.ArmSubsystem;
import org.firstinspires.ftc.teamcode.subsystem.ClawSubsystem;
import org.firstinspires.ftc.teamcode.subsystem.DualMotorSliderSubsystem;
import org.firstinspires.ftc.teamcode.subsystem.WristSubsystem;
//import org.firstinspires.ftc.teamcode.subsystem.HighBasketAutoPath2;
//import org.firstinspires.ftc.teamcode.subsystem.HighBasketAutoPath3;
//import org.firstinspires.ftc.teamcode.subsystem.HighBasketAutoPath4;
//import org.firstinspires.ftc.teamcode.subsystem.HighBasketAutoPath5;
//import org.firstinspires.ftc.teamcode.subsystem.HighBasketAutoPath6;
//import org.firstinspires.ftc.teamcode.subsystem.LiftActionsSubsystem;
//import org.firstinspires.ftc.teamcode.subsystem.SkyHookSubsystem;


@Autonomous(name = "Auto Test Competition V2", group = "Dev")
public class CometBotDriveV2 extends OpMode {
    private Follower follower;
    private int state;

    private HighBasketPath1 path1;



    //private CometBotTeleopCompetition comp;
    private static ElapsedTime runtime;
    private static boolean initalized = false;
    private static boolean followingPath = false;
    private DualMotorSliderSubsystem lift;
    private ClawSubsystem claw;
    private WristSubsystem wrist;
    private ArmSubsystem arm;

    @Override
    public void init() {
        follower = new Follower(hardwareMap);
        follower.setMaxPower(.75);

        path1 = new HighBasketPath1();

        lift = new DualMotorSliderSubsystem(hardwareMap);
        arm = new ArmSubsystem(hardwareMap);
        wrist = new WristSubsystem(hardwareMap);
        claw = new ClawSubsystem(hardwareMap);



        lift.init();
        arm.initAuto();
        wrist.InitAuto();
        claw.init();

        //comp = new CometBotTeleopCompetition(hardwareMap, telemetry, gamepad1, gamepad2);
       // comp.initCloseClaw();

    }


    public void loop() {
        telemetry.addData("state", state);
        telemetry.addData("followingPath", followingPath);
        telemetry.addData("busy", follower.isBusy());
        if (runtime != null) {
            telemetry.addData("Runtime (seconds)", runtime.seconds());
        }
        switch (state) {
            case 0:
                moveToPathOneAndHighBucket();
//                doArmThing1();
                break;
            case 1:
//                doArmThing2();
                break;
//            case 2:
//                moveToPathTwoAndPickSampleUp();
//                break;
//            case 3:
//                doPickUpThing();
//                break;
//            case 4:
//                moveToBasketPath3();
//                break;
//            case 5:
//                theArmThing();
//                break;
//            case 6:
//                moveToPickupAgainPath4();
//                break;
//            case 7:
//                doPickUpThingAgain();
//                break;
//            case 8:
//                moveToPickupAgainPath5();
//                break;
//            case 9:
//                //theArmThingAgain();
//                break;
//            case 10:
//                //moveToParkPath6();
//                break;
//            case 11:


        }
        telemetry.update();

        follower.update();


    }

    private void moveToPathOneAndHighBucket() {
            path1.moveToPath1(follower);
            state = 1;
    }

    public class SetStateAction implements Action {

        private int value;

        public SetStateAction(int value) {
            this.value = value;
        }
        @Override
        public boolean run(@NonNull TelemetryPacket telemetryPacket) {
            state = value;
            return false;
        }
    }

    private Action setStateValue(int value) {
        return new SetStateAction(value);
    }

    private void doArmThing1() {
        lift.toHighBucketPosition();
        arm.toBucketPosition();

        state = 2;
    }
    private void doArmThing2() {
       wrist.toBucketPosition();
       claw.openClaw();
       wrist.toFloorPosition();

        state = 2;
    }

//    private void theArmThing() {
//        telemetry.addData("busy?", follower.isBusy());
//        telemetry.addData("end?", follower.atParametricEnd());
//        if (follower.atParametricEnd()){
//            follower.breakFollowing();
//            comp.highBucketDropAuto();
//            state = 6;
//        }
//        follower.breakFollowing();
//    }

//    private void theArmThingAgain() {
//        follower.breakFollowing();
//        comp.highBucketDropAuto();
//        state = 10;
//    }

//    private void moveToPathTwoAndPickSampleUp() {
//        if (!followingPath) {
//            path2.moveToPath2(follower);
//            followingPath = true;
//        }
//        if (runtime != null) {
//            telemetry.addData("Runtime (seconds)", runtime.seconds());
//            if (follower.atParametricEnd() || runtime.seconds() > 22.0) {
//                state = 3;
//                followingPath = false;
//            }
//        }
//    }
//
//    private void moveToPickupAgainPath4() {
//        if (!followingPath) {
//            path4.moveToPickupAgainPath4(follower);
//            followingPath = true;
//        }
//        if (runtime != null) {
//            telemetry.addData("Runtime (seconds)", runtime.seconds());
//            if (follower.atParametricEnd() || runtime.seconds() > 27.0) {
//                state = 7;
//                followingPath = false;
//            }
//        }
//    }
//
//    private void moveToPickupAgainPath5() {
//        if (!followingPath) {
//            path5.moveToPickupAgainPath5(follower);
//            followingPath = true;
//        }
//        if (runtime != null) {
//            telemetry.addData("Runtime (seconds)", runtime.seconds());
//            if (follower.atParametricEnd() || runtime.seconds() > 36.0) {
//                state = 9;
//                followingPath = false;
//            }
//        }
//    }
//    private void moveToParkPath6() {
//        if (!followingPath) {
//            path6.moveToParkPath6(follower);
//            followingPath = true;
//        }
//        if (runtime != null) {
//            telemetry.addData("Runtime (seconds)", runtime.seconds());
//            if (follower.atParametricEnd() || runtime.seconds() > 48.0) {
//                state = 11;
//                followingPath = false;
//            }
//        }
//    }
//
//    private void moveToBasketPath3() {
//        if (!followingPath) {
//            path3.moveToBasketPath3(follower);
//            followingPath = true;
//        }
//        if (runtime != null) {
//            telemetry.addData("Runtime (seconds)", runtime.seconds());
//            if (follower.atParametricEnd() || runtime.seconds() > 10.0) {
//                state = 5;
//                followingPath = false;
//            }
//        }
//    }
//
//    private void thePickUpAuto() {
//        Actions.runBlocking(new SequentialAction(
//                new SleepAction(.1),
//                comp.claw.openClaw(),
//                new SleepAction(.2),
//                comp.wrist.toPickupPosition(),
//                new SleepAction(.2),
//                comp.arm.toSubmarinePosition(),
//                new SleepAction(.5),
//                comp.claw.closeClaw(),
//                new SleepAction(.3),
//                comp.wrist.toFloorPosition(),
//                new SleepAction(.2),
//                comp.arm.toParkPosition(),
//                new SleepAction(.2)
//        ));
//    }
//    private void thePickUp() {
//        Actions.runBlocking(new SequentialAction(
//                new SleepAction(.5),
//                comp.wrist.toPickupPosition(),
//                new SleepAction(.5),
//                comp.arm.toSubmarinePosition(),
//                new SleepAction(.7),
//                comp.claw.closeClaw(),
//                new SleepAction(.7),
//                comp.wrist.toFloorPosition(),
//                new SleepAction(.5),
//                comp.arm.toParkPosition(),
//                new SleepAction(.5)
//        ));
//    }
//
//    private void doPickUpThing() {
//        follower.breakFollowing();
//        thePickUpAuto();
//        state = 4;
//    }
//
//    private void doPickUpThingAgain() {
//        follower.breakFollowing();
//        thePickUpAuto();
//        state = 8;
//    }
//
//
}

